﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Rensyu1
{
    class Person
    {
        //フィールド
        private string name;
        private int age;
        private char gender;

        //プロパティ
        public string Name
        {
            get
            {
                return this.name;
            }
            set
            {
                if (value.Length == 0)
                {
                    this.name = "名無しさん";
                }
                else
                {
                    this.name = value;
                }
            }
        }

        public int Age
        {
            get
            {
                return this.age;
            }
            private set
            {
                if (value < 0)
                {
                    this.age = 0;
                }
                else
                {
                    this.age = value;
                }
            }
        }

        public char Gender
        {
            get
            {
                return this.gender;
            }
            private set
            {
                if (value == 'm' || value == 'f')
                {
                    this.gender = value;
                }
                else
                {
                    this.gender = 'm';
                }
            }
        }

        //コンストラクタ
        public Person(string name, int age, char gender)
        {
            this.Name = name;
            this.Age = age;
            this.Gender = gender;
        }

        //メソッド
        public string SelfIntroduction()
        {
            return "わたしは" + this.name + "、" + this.age + "才" + "、" + ((this.gender == 'm') ? "男性" : "女性") + "です。";
        }

        public string SelfIntroduction(string message)
        {
            return message + "\n" + this.SelfIntroduction();
        }

        public void AddAge()
        {
            this.age++;
        }
    }
}
